from typing import Generic, TypeVar

from rainbowadn.chain.reduction.reductionresult import ReductionResult
from rainbowadn.core.hashpoint import HashPoint

__all__ = ('Reduced',)

ReductorType = TypeVar('ReductorType')
AccumulatorType = TypeVar('AccumulatorType')


class Reduced(ReductionResult, Generic[ReductorType, AccumulatorType]):
    def __init__(self, reduced: HashPoint[AccumulatorType]):
        assert isinstance(reduced, HashPoint)
        self.reduced = reduced
