from typing import Generic, TypeVar

from rainbowadn.chain.reduction.reduction import Reduction
from rainbowadn.chain.reduction.reductionresult import ReductionResult
from rainbowadn.core.hashpoint import HashPoint
from rainbowadn.core.rainbow_factory import RainbowFactory

__all__ = ('ReductionProtocol',)

ReductorType = TypeVar('ReductorType')
AccumulatorType = TypeVar('AccumulatorType')


class ReductionProtocol(Generic[ReductorType, AccumulatorType]):
    async def reduce(
            self,
            reduction: Reduction[ReductorType, AccumulatorType]
    ) -> ReductionResult[ReductorType, AccumulatorType]:
        raise NotImplementedError

    def initial(self, factory: RainbowFactory[AccumulatorType]) -> HashPoint[AccumulatorType]:
        raise NotImplementedError

    async def header_filter(
            self,
            state: HashPoint[AccumulatorType]
    ) -> HashPoint[AccumulatorType]:
        raise NotImplementedError
