from typing import Generic, TypeVar

from rainbowadn.chain.stages.derivation.derived import Derived
from rainbowadn.core.hashpoint import HashPoint

__all__ = ('DerivedStage',)

BaseStateType = TypeVar('BaseStateType')
StageType = TypeVar('StageType')


class DerivedStage(Derived[BaseStateType, StageType], Generic[BaseStateType, StageType]):
    def __init__(self, stage: HashPoint[StageType]):
        assert isinstance(stage, HashPoint)
        self.stage = stage
