from typing import Generic, TypeVar

from rainbowadn.chain.stages.derivation.derived import Derived
from rainbowadn.core.hashpoint import HashPoint

__all__ = ('DerivedState',)

BaseStateType = TypeVar('BaseStateType')
StageType = TypeVar('StageType')


class DerivedState(Derived[BaseStateType, StageType], Generic[BaseStateType, StageType]):
    def __init__(self, state: HashPoint[BaseStateType]):
        assert isinstance(state, HashPoint)
        self.state = state
