from typing import Generic, TypeVar

from rainbowadn.core.asserts import assert_eq
from rainbowadn.core.hashpoint import HashPoint
from rainbowadn.core.metaorigin import MetaOrigin
from rainbowadn.core.origin import Origin
from rainbowadn.core.rainbow_factory import RainbowFactory

__all__ = ('LocalMetaOrigin',)

Mentioned = TypeVar('Mentioned')


class LocalMetaOrigin(MetaOrigin[Mentioned], Generic[Mentioned]):
    def __init__(self, origin: Origin[Mentioned]):
        assert isinstance(origin, Origin)
        self._origin = origin

    def origin(self, factory: RainbowFactory[Mentioned], point: bytes) -> Origin[Mentioned]:
        assert isinstance(factory, RainbowFactory)
        assert isinstance(point, bytes)
        assert_eq(len(point), HashPoint.HASH_LENGTH)
        return self._origin
