from typing import Generic, TypeVar

from rainbowadn.core.nullability.nullable import Nullable

__all__ = ('NotNull',)

NullableType = TypeVar('NullableType')


class NotNull(Nullable[NullableType], Generic[NullableType]):
    def null(self) -> bool:
        return False

    def _resolve(self) -> NullableType:
        return self._value

    def __init__(self, value: NullableType):
        self._value = value

    def __eq__(self, other):
        if isinstance(other, NotNull):
            return self._value == other._value
        else:
            return NotImplemented
