import abc
from typing import Iterable

from rainbowadn.core.hashpoint import HashPoint
from rainbowadn.core.mentionable import Mentionable

__all__ = ('RecursiveMentionable',)


class RecursiveMentionable(Mentionable, abc.ABC):
    def points(self) -> Iterable[HashPoint]:
        raise NotImplementedError

    async def str(self, tab: int) -> str:
        assert isinstance(tab, int)
        return f'(recursive {self.__class__.__name__})'

    def __topology_hash__(self) -> bytes:
        return HashPoint.hash(b''.join(hash_point.point for hash_point in self.points()))
