from typing import Generic, TypeVar

from rainbowadn.core.asserts import assert_eq
from rainbowadn.core.hashpoint import HashPoint
from rainbowadn.core.hashresolver import HashResolver
from rainbowadn.core.metaorigin import MetaOrigin
from rainbowadn.core.origin import Origin
from rainbowadn.core.rainbow_factory import RainbowFactory
from rainbowadn.core.resolverorigin import ResolverOrigin

__all__ = ('ResolverMetaOrigin',)

Mentioned = TypeVar('Mentioned')


class ResolverMetaOrigin(MetaOrigin[Mentioned], Generic[Mentioned]):
    def __init__(self, resolver: HashResolver):
        assert isinstance(resolver, HashResolver)
        self.resolver = resolver

    def origin(self, factory: RainbowFactory[Mentioned], point: bytes) -> Origin[Mentioned]:
        assert isinstance(factory, RainbowFactory)
        assert isinstance(point, bytes)
        assert_eq(len(point), HashPoint.HASH_LENGTH)
        return ResolverOrigin(factory, point, self.resolver)
