from typing import Generic, Optional, TypeVar

from rainbowadn.data.collection.trees.binary.binarycreation import BinaryCreation
from rainbowadn.data.collection.trees.binary.binarysplit import BinarySplit

__all__ = ('BinaryProtocolized',)

TreeType = TypeVar('TreeType')
ActiveKeyType = TypeVar('ActiveKeyType')
MetaDataType = TypeVar('MetaDataType')


class BinaryProtocolized(
    Generic[ActiveKeyType, MetaDataType, TreeType]
):
    def __init__(
            self,
            protocol: BinaryCreation[ActiveKeyType, MetaDataType, TreeType],
            tree: TreeType
    ):
        assert isinstance(protocol, BinaryCreation)
        self.protocol = protocol
        self.tree = tree

    async def split(self) -> Optional[BinarySplit[ActiveKeyType, MetaDataType, TreeType]]:
        return await self.protocol.split(self.tree)
