from typing import Generic, TypeVar

from rainbowadn.core.hashpoint import HashPoint

__all__ = ('BinarySplit',)

TreeType = TypeVar('TreeType')
ActiveKeyType = TypeVar('ActiveKeyType')
MetaDataType = TypeVar('MetaDataType')


class BinarySplit(
    Generic[ActiveKeyType, MetaDataType, TreeType]
):
    def __init__(
            self,
            treel: TreeType,
            key: HashPoint[ActiveKeyType],
            metadata: HashPoint[MetaDataType],
            treer: TreeType
    ):
        assert isinstance(key, HashPoint)
        assert isinstance(metadata, HashPoint)
        self.treel = treel
        self.key = key
        self.metadata = metadata
        self.treer = treer
